/* This is a modification of the mdump.c code Copyright by EDF France
   abaqus / calculix interface capabilities, Bernhardi, Oct 2009   */
/****************************************************************************
* COPYRIGHT (C) 1999 - 2003  EDF R&D
*
* THIS LIBRARY IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
* IT UNDER THE TERMS OF THE GNU LESSER GENERAL PUBLIC LICENSE 
* AS PUBLISHED BY THE FREE SOFTWARE FOUNDATION; 
* EITHER VERSION 2.1 OF THE LICENSE, OR (AT YOUR OPTION) ANY LATER VERSION.
*  
* THIS LIBRARY IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
* WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
* MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
* LESSER GENERAL PUBLIC LICENSE FOR MORE DETAILS.
*
* YOU SHOULD HAVE RECEIVED A COPY OF THE GNU LESSER GENERAL PUBLIC LICENSE
* ALONG WITH THIS LIBRARY; IF NOT, WRITE TO THE FREE SOFTWARE FOUNDATION,
* INC., 59 TEMPLE PLACE, SUITE 330, BOSTON, MA 02111-1307 USA
*
* - Nom du fichier : medaba10.c
*
*****************************************************************************/
#include <med.h>
#include <med_utils.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

/* nombre de mailles concernees par les equivalences */
#define NBR_MAILLE_EQU  7

void lecture_maillage_non_structure(med_idt fid,char *nommaa,med_int mdim,
med_mode_switch mode_coo, med_connectivite typ_con,
int lecture_en_tete_seulement, FILE *fp)                                       {

void exitif(int, char*, char*);
med_err ret = 0;
int i,j,k,l;

/* nombre d'objets MED */
med_int nnoe;
med_int nmai[MED_NBR_GEOMETRIE_MAILLE],nfac[MED_NBR_GEOMETRIE_FACE];
med_int nare[MED_NBR_GEOMETRIE_ARETE];

/* noeuds */
med_float *coo;
char nomcoo[3*MED_TAILLE_PNOM+1];
char unicoo[3*MED_TAILLE_PNOM+1];
char *nomnoe;
med_int *numnoe;
med_int *nufano; 
med_repere rep;
med_booleen inonoe,inunoe;
char str[MED_TAILLE_PNOM+1];

/* elements */
med_int edim;
med_int taille;
med_int *connectivite;
char *nomele;
med_int *numele;
med_int *nufael;
med_booleen inoele, inuele;
med_geometrie_element typgeo;

/* interface to abaqus/CalculiX. */
med_int *conneclow;
char *nomelelow;
med_booleen inoelelow;
med_booleen inuelelow;
med_int *numelelow;
med_int *nufaellow; 
med_int *family;
med_int edimlow;
med_int taillelow;
med_int *surfnum, *volelnum, *facenum;
med_int *nodesets;
med_int surfnumber, surfcounter, elementnumber;
med_int facnod, nodcount;
med_int facepoint, maxface, famcount;
med_int m,n,o,p,q,r,s;

med_geometrie_element typmai[MED_NBR_GEOMETRIE_MAILLE] =                  {
MED_POINT1,MED_SEG2, MED_SEG3,MED_TRIA3, MED_TRIA6,MED_QUAD4,
MED_QUAD8,MED_TETRA4, MED_TETRA10,MED_HEXA8, MED_HEXA20,MED_PENTA6,
MED_PENTA15,MED_PYRA5, MED_PYRA13                                         };
med_int desmai[MED_NBR_GEOMETRIE_MAILLE] = {0,2,3,3,3,4,4,4,4,6,6,5,5,5,5};
med_int nmailles[MED_NBR_GEOMETRIE_MAILLE];

char nommai[MED_NBR_GEOMETRIE_MAILLE] [MED_TAILLE_NOM+1] =                {
"MED_POINT1", "MED_SEG2", "MED_SEG3", "MED_TRIA3", 
"MED_TRIA6", "MED_QUAD4", "MED_QUAD8",
"MED_TETRA4", "MED_TETRA10", "MED_HEXA8", "MED_HEXA20", "MED_PENTA6",
"MED_PENTA15", "MED_PYRA5", "MED_PYRA13"                                  };

int numnodes[MED_NBR_GEOMETRIE_MAILLE]= {0,0,3,3,6,0,8,4,10,8,20,6,15,0,0};

/* seqabq contains MED element connectivities in abaqus sequence.*/
int seqabq[MED_NBR_GEOMETRIE_MAILLE][21]=                                 {
0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,  /* null  */
0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,  /* null  */
1,3,2,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,  /* B32   */
1,3,2,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,  /* S3    */
1,3,2,6,5,4,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,  /* CPS6  */
0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,  /* null  */
1,4,3,2,8,7,6,5,0,0, 0,0,0,0,0,0,0,0,0,0, 0,  /* CPS8  */
1,3,2,4,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,  /* C3D4  */
1,3,2,4,7,6,5,8,10,9, 0,0,0,0,0,0,0,0,0,0, 0, /* C3D10, salome */
/* 1,2,3,4,5,6,7,8,9,10, 0,0,0,0,0,0,0,0,0,0, 0, */ /* C3D10, gmsh */
1,4,3,2,5,8,7,6,0,0, 0,0,0,0,0,0,0,0,0,0, 0,  /* C3D8  */
1,4,3,2,5,8,7,6,12,11,10, 9,16,15,14,13,17,20,19,18, 0,  /* C3D20 */
1,3,2,4,6,5,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,  /* C3D6  */
1,3,2,4,6,5,9,8,7,12, 11,10,13,15,14, 0, 0,0,0,0, 0,  /* C3D15 */
0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0,  /* null  */
0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0, 0   /* null  */                 };

/* pointers to faces tables. */
int elpointer[MED_NBR_GEOMETRIE_MAILLE] =                                 {
0, 0, 0, 5, 5, 0, 4, 3, 3, 2, 2, 1, 1, 0, 0                               };

/* faces contains abaqus face numbers tabulated against MED/salome node numbering scheme. */
int  faces[6][7][5]   =                                                   {

0, 0, 0, 0, 0,
0, 0, 0, 0, 0,
0, 0, 0, 0, 0,
0, 0, 0, 0, 0,
0, 0, 0, 0, 0,
0, 0, 0, 0, 0,
0, 0, 0, 0, 0,

5, 0, 0, 0, 0,                       /* wedges 6/15 nodes.  */
3, 1, 2, 3, 0, 
3, 4, 5, 6, 0, 
3, 1, 3, 4, 6,
4, 2, 3, 5, 6,
4, 1, 2, 4, 5, 
0, 0, 0, 0, 0, 

6, 0, 0, 0, 0,                       /* Bricks 8/20 nodes. */
4, 1, 2, 3, 4,
4, 5, 6, 7, 8,
4, 1, 4, 5, 8,
4, 3, 4, 7, 8,
4, 2, 3, 6, 7,
4, 1, 2, 5, 6,

4, 0, 0, 0, 0,                       /* tetrahedra, 4/10 nodes. */
3, 1, 2, 3, 0,
3, 1, 3, 4, 0, 
3, 2, 3, 4, 0, 
3, 1, 2, 4, 0, 
0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 

4, 0, 0, 0, 0,                       /* quadrilaterals, 4/8 nodes. */
2, 1, 4, 0, 0, 
2, 3, 4, 0, 0, 
2, 2, 3, 0, 0, 
2, 1, 2, 0, 0, 
0, 0, 0, 0, 0, 
0, 0, 0, 0, 0,

3, 0, 0, 0, 0,                       /* triangles, 3/6 nodes. */
2, 1, 3, 0, 0, 
2, 2, 3, 0, 0,
2, 1, 2, 0, 0, 
0, 0, 0, 0, 0, 
0, 0, 0, 0, 0, 
0, 0, 0, 0, 0                                                               };

int maxdimen, mindimen;

char nomabq[MED_NBR_GEOMETRIE_MAILLE] [MED_TAILLE_NOM+1] =                  {
"null", "null", "B32", "S3", "CPS6", "null", "CPS8",
"C3D4", "C3D10", "C3D8", "C3D20", "C3D6", "C3D15", "null", "null"           };

med_geometrie_element typfac[MED_NBR_GEOMETRIE_FACE] =                      {
MED_TRIA3,MED_TRIA6, MED_QUAD4,MED_QUAD8                                    };

med_int desfac[MED_NBR_GEOMETRIE_FACE] = {3,3,4,4};

char nomfac[MED_NBR_GEOMETRIE_FACE][MED_TAILLE_NOM+1] =                     {
"MED_TRIA3", "MED_TRIA6", "MED_QUAD4", "MED_QUAD8"                          };

med_geometrie_element typare[MED_NBR_GEOMETRIE_ARETE] = {MED_SEG2, MED_SEG3};
med_int desare[MED_NBR_GEOMETRIE_ARETE] = {2,3};
med_int naretes[MED_NBR_GEOMETRIE_ARETE];
char nomare[MED_NBR_GEOMETRIE_ARETE] [MED_TAILLE_NOM+1] = {"MED_SEG2", "MED_SEG3"};

/* familles */
med_int nfam;
med_int natt,ngro;
char *attdes,*gro;
med_int *attval,*attide;
char nomfam[MED_TAILLE_NOM+1];
med_int numfam;
char str1[MED_TAILLE_DESC+1];
char str2[MED_TAILLE_LNOM+1];
char *famnames;
med_int *famnumbers;

/* groupes. */
char **groupnames;
med_int *groupnumbers;
char* groups;
int match, grptr;
int groupcount, matchcount;

/* equivalences */
med_int nequ,ncor;
med_int *cor;
char equ[MED_TAILLE_NOM+1];
char des[MED_TAILLE_DESC+1];

/* mailles/faces MED_POLYGONE et MED_POLYEDRE */
med_int nmpolygones,nfpolygones,npolyedres;
med_int *indexp, *indexf;
int ind1,ind2,np,nf;
char tmp[MED_TAILLE_NOM+1];
med_err ret1,ret2,ret3;
med_int nfa;

/* Combien de noeuds ? */
nnoe = MEDnEntMaa(fid,nommaa,MED_COOR,MED_NOEUD,0,0);
exitif(nnoe < 0,"lors de la lecture du nombre de noeuds",NULL);
fprintf(stdout,"- Nombre de noeuds : %d \n",nnoe);
  
/* Combien de mailles, faces ou aretes ? */
for (i=0;i<MED_NBR_GEOMETRIE_MAILLE;i++)                                    {
nmailles[i] = MEDnEntMaa(fid,nommaa,MED_CONN,MED_MAILLE,typmai[i], typ_con);
exitif(nmailles[i] < 0," lors de la lecture du nombre de mailles",NULL);
if(nmailles[i]>0) 
fprintf (stdout,"- Nombre de mailles de type %s : %d \n",nommai[i],nmailles[i]);
                                                                            }
/* nombre de familles */
nfam = MEDnFam(fid,nommaa);
exitif(nfam < 0,"lors de la lecture du nombre de familles",NULL);
fprintf(stdout,"- Nombre de familles : %d \n",nfam);

/* combien d'equivalences dans le fichier */
nequ = MEDnEquiv(fid,nommaa);
exitif(nequ < 0,"lors de la lecture du nombre d'equivalences",NULL);
fprintf(stdout,"- Nombre d'equivalences : %d \n",nequ);
/*=============================================================================*/
/* LECTURE DES FAMILLES */
famnames=(char*) malloc(sizeof(char)*nfam*MED_TAILLE_LNOM);
exitif(famnames == NULL,NULL,NULL);
famnumbers=(med_int*) malloc(sizeof(med_int)*nfam);
exitif(famnumbers == NULL,NULL,NULL);
groupnames=(char**)malloc(sizeof(char*)*nfam);

/* table of groupnames in all families. */
exitif(groupnames ==NULL,NULL,NULL);

/* list of numbers of groups for each family. */
groupnumbers=(med_int*)malloc(sizeof(med_int)*nfam);
exitif(groupnumbers==NULL, "lors de l'allocation de groupnumbers", NULL);

for (i=0;i<nfam;i++)                                                        {

/* nombre de groupes */
ngro = MEDnGroupe(fid,nommaa,i+1);
exitif(ngro < 0,"lors de la lecture du nombre de groupe d'une famille",NULL);
	
/* nombre d'attributs */
natt = MEDnAttribut(fid,nommaa,i+1);
exitif(natt < 0,"lors de la lecture du nombre d'attributs d'une famille",NULL);

fprintf(stdout,"- Famille %d a %d attribut(s) et %d groupe(s) \n",i+1,natt,ngro);

/* nom,numero,attributs,groupes */
/* allocation memoire */
if (natt > 0)                                                       {
attide = (med_int*) malloc(sizeof(med_int)*natt);
exitif(attide == NULL,NULL,NULL);
attval = (med_int*) malloc(sizeof(med_int)*natt);
exitif(attval == NULL,NULL,NULL);	    
attdes = (char *) malloc(MED_TAILLE_DESC*natt+1);
exitif(attdes == NULL,NULL,NULL);                                  } 
else                                                                {
attide = NULL;
attval = NULL;
attdes = NULL;                                                      }

if (ngro > 0)                                                       {
gro = (char*) malloc(MED_TAILLE_LNOM*ngro+1);
exitif(gro == NULL,NULL,NULL);                                     } 
else                                                                {
gro = NULL;                                                         }

/* lire information sur les familles. */
ret=MEDfamInfo(fid,nommaa,i+1,nomfam,&numfam,attide,attval,attdes,&natt,gro,&ngro);
exitif(ret < 0,"lors de la lecture des informations d'une famille", NULL);

/* allocation memoire; groups */
groupnumbers[i]=ngro;
if(ngro>0)                                                          {
 groupnames[i]=(char*)malloc(sizeof(char)*ngro*MED_TAILLE_LNOM);
exitif(groupnames[i]==NULL, "lors de l'allocation de groupnames[i]", NULL);
                                                                    }
else groupnames[i]=NULL;

fprintf(stdout,"  - Famille de nom %s et de numero %d : \n",nomfam,numfam);
famnumbers[i]=numfam;
strncpy(famnames+i*MED_TAILLE_LNOM, nomfam, MED_TAILLE_LNOM);

/* affichage des resultats */
fprintf(stdout,"  - Attributs : \n");
for (j=0;j<natt;j++)                                                {
strncpy(str1,attdes+j*MED_TAILLE_DESC,MED_TAILLE_DESC); 
str1[MED_TAILLE_DESC] = '\0';
fprintf(stdout,"   identificateur = %d - valeur = %d - description = %s\n",
*(attide+j), *(attval+j),str1);                                     }

if (natt > 0)                                                       {
free(attide);
free(attval);
free(attdes);                                                       }

if(ngro>0)                                                          {
fprintf(stdout,"  - Groupes :\n");
for (j=0;j<ngro;j++)                                           {
strncpy(groupnames[i]+j*MED_TAILLE_LNOM, gro+j*MED_TAILLE_LNOM, 
MED_TAILLE_LNOM);
strncpy(str2,gro+j*MED_TAILLE_LNOM,MED_TAILLE_LNOM);
str2[MED_TAILLE_LNOM] = '\0';
fprintf(stdout,"   groupe %d  = %s\n",j+1,str2);               }
free(gro);                                                          }        }

fprintf(stdout, "\nList of families and their names. \n");
for(i=0;i<nfam;i++)                                                          {
fprintf(stdout, "%d, %s\n", i, famnames+i*MED_TAILLE_LNOM);                  }

/* combien des groups? */
groupcount=0;
for(i=0;i<nfam;i++)groupcount+=groupnumbers[i];
fprintf(stdout, "total of %d groups present in all families. \n", groupcount);

/* generate group list. */
groups=(char*)malloc(sizeof(char)*groupcount*MED_TAILLE_LNOM);
exitif(groups==NULL, "lors de L'allocation de groups[]", NULL);
grptr=0;

for(i=0;i<nfam;i++)                                                         {

/* for(j=0;j<groupnumbers[i];j++) fprintf(stdout, " i=%d, groupnames=%s\n",
 i,groupnames[i]+j*MED_TAILLE_LNOM);
for(j=0;j<grptr;j++) fprintf(stdout, " j=%d, groups=%s\n",
 j,groups+j*MED_TAILLE_LNOM); */

for(j=0;j<groupnumbers[i];j++)                                     {
matchcount=0;
/* fprintf(stdout, "i=%d, j=%d, grptr=%d\n", i,j,grptr); */
for(k=0;k<=grptr;k++)                                     {
match=strncmp(groups+MED_TAILLE_LNOM*k,groupnames[i]+MED_TAILLE_LNOM*j,
MED_TAILLE_LNOM);
/* fprintf(stdout, "match=%d, groups[k]=%s, groupnames[i][j]=%s\n",
match, groups+MED_TAILLE_LNOM*k, groupnames[i]+MED_TAILLE_LNOM*j); */
if(match==0) matchcount++;                                }
if(matchcount>1)                                          {
fprintf(stdout, "Error: wrong matchcount=%d\n", matchcount);
exit(0);                                                  }
if(matchcount==0||grptr==0)                               {
strncpy(groups+grptr*MED_TAILLE_LNOM, groupnames[i]+MED_TAILLE_LNOM*j,
MED_TAILLE_LNOM);
grptr++;                                                  }         }       }

fprintf(stdout, "total of %d groups found. \n", grptr);
for(j=0;j<grptr;j++) fprintf(stdout, "%d %s\n", j+1,groups+j*MED_TAILLE_LNOM);

/*==============================================================================*/
/* LECTURE DES NOEUDS */
  
/* Allocations memoires */
/* table des coordonnees profil : (dimension * nombre de noeuds ) */
coo = (med_float*) malloc(sizeof(med_float)*nnoe*mdim);
exitif(coo == NULL,NULL,NULL);

/* table  des numeros, des numeros de familles des noeuds */
numnoe = (med_int*) malloc(sizeof(med_int)*nnoe);
exitif(numnoe == NULL,NULL,NULL);
nufano = (med_int*) malloc(sizeof(med_int)*nnoe);
exitif(nufano == NULL,NULL,NULL);

/* table des noms des noeuds profil : (nnoe*MED_TAILLE_PNOM+1) */
nomnoe = (char*) malloc(MED_TAILLE_PNOM*nnoe+1);
exitif(nomnoe == NULL,NULL,NULL);

/* lecture des noeuds : coordonnees, noms, numeros, numeros des familles */
ret = MEDnoeudsLire(fid,nommaa,mdim,coo,mode_coo,&rep,
 nomcoo,unicoo,nomnoe,&inonoe,numnoe,&inunoe, nufano,nnoe);
exitif(ret < 0,"lors de la lecture des noeuds du maillage \n",NULL);
if(numnoe[0]==0)                                                            {
fprintf(stdout, "First node has no number. Generating new node numbers.\n");
for(i=0;i<nnoe;i++) numnoe[i]=i+1;                                          }

/* affichage des resultats */
fprintf(stdout,"\n-------------------------------------------------------------\n");
fprintf(stdout,"NOEUDS DU MAILLAGE:\n");
fprintf(stdout,"- Type de repere des coordonnees : %d \n",rep);
fprintf(stdout,"- Nom des coordonnees : \n");
for (i=0;i<mdim;i++)                                                        {
strncpy(str,nomcoo+i*MED_TAILLE_PNOM,MED_TAILLE_PNOM);
str[MED_TAILLE_PNOM] = '\0';
fprintf(stdout," %s ",str);                                                 }

fprintf(stdout,"\n- Unites des coordonnees : \n");
for (i=0;i<mdim;i++)                                                        {
strncpy(str,unicoo+i*MED_TAILLE_PNOM,MED_TAILLE_PNOM);
str[MED_TAILLE_PNOM] = '\0';
fprintf(stdout," %s ",str);                                                 } 
fprintf(stdout, "\n");

/* print out to abaqus. */
fprintf(fp,"*node, nset=nall\n");
for(i=0;i<=nnoe-1;i++)                                                      {
if(i%10000==0) fprintf(stdout, "writing node %d\n", i);
fprintf(fp, "%d, ",*(numnoe+i));
for(k=0; k<=mdim-1;k++) fprintf(fp, "%g, ",  *(coo+mdim*i+k));
fprintf(fp, "\n");                                                          }

/* ecrire les node sets correspondant aux groupes. */
for(m=0;m<grptr;m++)                                                        {
fprintf(stdout, "writing node group set %d, ", m);
fprintf(stdout, "%s\n", groups+m*MED_TAILLE_LNOM);
famcount=0;
for(i=0;i<nfam;i++)                                                    {
for(j=0;j<groupnumbers[i];j++)                                      {
match=strncmp(groups+MED_TAILLE_LNOM*m,groupnames[i]+MED_TAILLE_LNOM*j,
MED_TAILLE_LNOM);
if(match==0)                                                     {
for(n=0;n<=nnoe-1;n++)                                        {
if(*(nufano+n)==famnumbers[i])                             {
famcount++;
if(famcount%8==0) fprintf(fp,"\n");
if(famcount==1) fprintf(fp,"\n*nset, nset=%s\n", groups+m*MED_TAILLE_LNOM);
fprintf(fp,"%d, ",*(numnoe+n));                            }  }  }  }  }    }
/*=============================================================================*/
/* LECTURE DES ELEMENTS */

fprintf(stdout,"\n------------------------------------------------------------\n");
fprintf(stdout,"ELEMENTS DU MAILLAGE : \n");

/* check for largest dimension of elements in the mesh. */
maxdimen=0;
for (i=0;i<MED_NBR_GEOMETRIE_MAILLE;i++)                                   {
if (nmailles[i] > 0)                                                {
edim = typmai[i] / 100;
if(edim>maxdimen) maxdimen=edim;                                    }      }
fprintf(stdout, "dimension of mesh (maxdimen)=%d\n", maxdimen);
exitif(maxdimen<=0, "wrong dimension of mesh.",NULL);
mindimen=maxdimen-1;

/* check number of 'surface' mesh members. */
surfnumber=0;
for (i=0;i<MED_NBR_GEOMETRIE_MAILLE;i++)                                   {
edim=typmai[i]/100;   
if(edim==maxdimen && nmailles[i]>0 ) surfnumber=surfnumber+nmailles[i];    }
surfnumber=surfnumber*6;
fprintf(stdout, "max number of surface elements (surfnumber)= %d\n", surfnumber);

/* allocate memory for surface elements. */
surfnum= (med_int*)malloc(sizeof(med_int)*surfnumber);
exitif(surfnum == NULL,NULL,NULL);
volelnum= (med_int*)malloc(sizeof(med_int)*surfnumber);
exitif(volelnum == NULL,NULL,NULL);
facenum= (med_int*)malloc(sizeof(med_int)*surfnumber);
exitif(facenum == NULL,NULL,NULL);
family= (med_int*)malloc(sizeof(med_int)*surfnumber);
exitif(family == NULL,NULL,NULL);

/* reset surface counter. */
surfcounter=0;
elementnumber=0;
  
/* Lecture des connectivites, noms, numeros des mailles */
for (i=0;i<MED_NBR_GEOMETRIE_MAILLE;i++)                                   {
if (nmailles[i] > 0 )                                                 {
     
/* dimension de la maille */
edim = typmai[i] / 100;
taille = typmai[i]%100;
if(edim==maxdimen)                                                {                   
/* allocation memoire */
fprintf(stdout, "allocating: nmailles[%d]=%d, taille=%d\n", 
 i, nmailles[i], taille);
connectivite = (med_int*)malloc(sizeof(med_int)*taille*nmailles[i]);
exitif(connectivite == NULL,NULL,NULL);
nomele = (char*)malloc(sizeof(char)*MED_TAILLE_PNOM*nmailles[i]+1);
exitif(nomele == NULL,NULL,NULL);
numele = (med_int*)malloc(sizeof(med_int)*nmailles[i]);
exitif(numele == NULL,NULL,NULL);
nufael = (med_int*)malloc(sizeof(med_int)*nmailles[i]);
exitif(nufael == NULL,NULL,NULL);
	    
/* lecture des donnees */
ret = MEDelementsLire(fid,nommaa,mdim,connectivite,mode_coo,
nomele,&inoele,numele,&inuele,nufael, nmailles[i],MED_MAILLE,typmai[i], typ_con);
exitif(ret < 0, "lors de la lecture des mailles", NULL);
/* for(j=0;j<taille*nmailles[i];j++) fprintf(stdout, "%d\n", connectivite[j]); */
if(nmailles[0]==0)                                           {
fprintf(stdout, "First element has no number. Generating new element numbers.\n");
for(j=0;j<nmailles[i];j++)                               {
elementnumber++;
numele[j]=elementnumber;                                 }   }
      
/* affichage des resultats */
fprintf(stdout,"\n- Mailles de type %s:\n", nommai[i]);

/* print out connectivity to abaqus. */
l=numnodes[i];
if(l>0)                                                      {
fprintf(fp, "\n*element, elset=%s,type=%s\n", nomabq[i], nomabq[i]);
for(j=0;j<=nmailles[i]-1;j++)                            {
if(j%10000==0) fprintf(stdout, "writing element %d\n", j);
fprintf(fp, "%d, ",*(numele+j));
for(k=0; k<=taille-1;k++)                           {
if(k==15) fprintf(fp,"\n"); 
fprintf(fp, "%d, ", *(numnoe + *(connectivite+taille*j+seqabq[i][k]-1)-1));
                                                    }
fprintf(fp, "\n");                                       }
if(i<=2)                                                 {
fprintf(fp, "*beam section, section=rectangular, material=steel, elset=%s\n", 
nomabq[i]);                                              }
else                                                     {
fprintf(fp, "*solid section, material=steel, elset=%s\n", nomabq[i]);
                                                         }   }

/* ecrire les element sets correspondant aux groupes. */
for(m=0;m<grptr;m++)                                         {
fprintf(stdout, "writing element group set %d, ", m);
fprintf(stdout, "%s\n", groups+m*MED_TAILLE_LNOM);
famcount=0;
for(o=0;o<nfam;o++)                                      {
for(j=0;j<groupnumbers[o];j++)                       {
match=strncmp(groups+MED_TAILLE_LNOM*m,groupnames[o]+MED_TAILLE_LNOM*j,
MED_TAILLE_LNOM);
if(match==0)                                     {
for(n=0;n<nmailles[i];n++)                    {
if(*(nufael+n)==famnumbers[o])             {
famcount++;
if(famcount%8==0) fprintf(fp,"\n");
if(famcount==1) fprintf(fp,"\n*elset, elset=%s\n", groups+m*MED_TAILLE_LNOM);
fprintf(fp,"%d, ",*(numele+n));            }  }  }   }   }   }

/* second loop on all meshes -- check for surface meshes only. */
for (l=0;l<MED_NBR_GEOMETRIE_MAILLE;l++)                    {
fprintf(stdout, "reading mesh number %d of %d\n", l, MED_NBR_GEOMETRIE_MAILLE);
edimlow = typmai[l] / 100;
if (nmailles[l] > 1 && mindimen==edimlow)             {
printf("\n- Surface elements: Mailles de type %s:\n", nommai[l]);
taillelow = typmai[l]%100;
	    
/* allocation memoire: surface meshes */
conneclow = (med_int*)malloc(sizeof(med_int)*taillelow*nmailles[l]);
exitif(conneclow == NULL,NULL,NULL);
nomelelow = (char*)malloc(sizeof(char)*MED_TAILLE_PNOM*nmailles[l]+1);
exitif(nomelelow == NULL,NULL,NULL);
numelelow = (med_int*)malloc(sizeof(med_int)*nmailles[l]);
exitif(numelelow == NULL,NULL,NULL);
nufaellow = (med_int*)malloc(sizeof(med_int)*nmailles[l]);
exitif(nufaellow == NULL,NULL,NULL);
	    
/* lecture des donnees: surface meshes */
ret = MEDelementsLire(fid,nommaa,mdim,conneclow,mode_coo,nomelelow,
&inoelelow,numelelow,&inuelelow,nufaellow, nmailles[l],MED_MAILLE,
typmai[l], typ_con);
exitif(ret < 0, "lors de la lecture des mailles", NULL);

/* convertir les maillages surface en notation ABAQUS */
facepoint=elpointer[i];                   /* points to faces table . */
maxface=faces[facepoint][0][0];           /* number of faces at this element. */
/* fprintf(stdout, "surf=%d, vol=%d, facepoint=%d, maxface=%d\n",
  n,o,facepoint, maxface);  */
for(n=0;n<=nmailles[l]-1;n++)       {     /* surface elements */
if(*(nufaellow+n)!=0)              {
if(n%1000==0) fprintf(stdout, "converting surface element %d\n", n);
for(o=0;o<=nmailles[i]-1;o++)    {        /* volume elements */
for(p=1;p<=maxface;p++)       {          /* all surfaces of vol element */
facnod=faces[facepoint][p][0];           /* number of nodes at this surface. */
/* fprintf(stdout, "facnod=%d\n", facnod);  */
nodcount=0;
for(q=1;q<=facnod;q++)     {             /* all edge nodes on surface of volel*/
s=faces[facepoint][p][q];
for(r=1;r<=facnod;r++)   {               /* all edge nodes on surface */
if (*(connectivite+taille*o+s-1)==*(conneclow+taillelow*n+r-1)) nodcount++;
                         }
if(nodcount-q<0) break;    }
/* fprintf(stdout, "n=%d, o=%d, p=%d, nodcount=%d\n", n,o,p,nodcount); */

if(facnod==nodcount)       {
*(surfnum+surfcounter)=*(numelelow+n);
*(volelnum+surfcounter)= *(numele+o);
*(facenum+surfcounter)= p; 
*(family+surfcounter)=*(nufaellow+n);
surfcounter++;
if(surfcounter>surfnumber){
fprintf(stdout, "error too many surfaces found.\n");
exitif(ret < 0, "lors de l'indification des surfaces", NULL);
                          } } }  } }}  

fprintf(stdout, "surfcounter=%d\n", surfcounter);
/* liberation memoire  -- surface meshes  */
free(conneclow);
free(nomelelow);
free(numelelow);
free(nufaellow);                                       }     }
fprintf(stdout, "all submeshes done. \n");

/* liberation memoire  - volume mesh*/
free(nufael);
free(connectivite);
free(nomele);
free(numele);

/* end loops over all elements. */                                }   }    }
fprintf(stdout, "all main meshes done. \n");

/* ecrire les element surface sets correspondant aux groupes. */
for(m=0;m<grptr;m++)                                                       {
fprintf(stdout, "writing element surface group set %d, ", m);
fprintf(stdout, "%s\n", groups+m*MED_TAILLE_LNOM);
for(o=0;o<nfam;o++)                                                   {
for(j=0;j<groupnumbers[o];j++)                                    {
match=strncmp(groups+MED_TAILLE_LNOM*m,groupnames[o]+MED_TAILLE_LNOM*j,
MED_TAILLE_LNOM);
if(match==0)                                                   {
for(p=1;p<=6;p++)                                            {
famcount=0;
for(q=0;q<=surfcounter;q++)                                {
if(*(family+q)==famnumbers[o]
&&*(facenum+q)==p)                                        {
famcount++;
if(famcount%8==0) fprintf(fp,"\n");
if(famcount==1) fprintf(fp,"\n*elset, elset=%sF%d\n",
groups+m*MED_TAILLE_LNOM, p);
fprintf(fp,"%d, ",*(volelnum+q));                         } } } }   }   }   }

/* liberer memoire, surfaces des 3-d elements. */
free(surfnum);
free(volelnum);
free(facenum);
free(family);

/* liberation memoire -- noeuds. */
free(coo);
free(nomnoe);
free(numnoe);
free(nufano);

/* liberation memoire -- familles. */
fprintf(stdout, "freeing famnames and famnumbers arrays. \n");
free(famnames);
free(famnumbers);
fprintf(stdout, "returning to main().\n");
                                                                               }
/******************************************************************************
 * - Nom de la fonction : main
 * - Description : outil de DUMP d'un fichier MED.
 * - Parametres :
 *     - argc  (IN) : nombre d'arguments sur la ligne de commande.
 *     - argv  (IN) : liste des arguments.
 ******************************************************************************/
int main (int argc, char **argv)                                               {
void exitif(int, char*, char*);
med_err ret = 0;
int reponse;
med_idt fid;
int i;
int numero;
med_mode_switch mode_coo;
med_connectivite typ_con;
int lecture_en_tete_seulement = 0;
char nom_universel[MED_TAILLE_LNOM+1];
med_int long_fichier_en_tete; 
char *fichier_en_tete;
char version_hdf[10];
char version_med[10];
med_int mdim,nmaa;

/* nom du maillage */
char nommaa[MED_TAILLE_NOM+1];
char maillage_description[MED_TAILLE_DESC+1];
med_maillage type_maillage;
med_int edim;
med_int majeur,mineur,release;
med_int majeur_lu,mineur_lu,release_lu;
med_int nprofils;
FILE *fp;  /* ABAQUS input file: abaqus.inp. */
char filename[50]; /* abaqus - input - file name. */ 
char inname[50]; /* input file name. */
/****************************************************************************
*                  TEST DU NOMBRE D'ARGUMENTS                               *
*                  argument 1 = nom du fichier MED                          *
****************************************************************************/
fprintf(stdout, "argc=%d\n", argc);
exitif(argc != 2,"usage: medaba MED_filename (without extension .med)",NULL);
strcpy(inname, argv[1]);
strcat(inname, ".med");
/****************************************************************************
*                      OUVERTURE DU FICHIER EN LECTURE                      *
****************************************************************************/
fprintf(stdout, "Lecture du fichier %s\n",inname);

/* on regarde s'il s'agit d'un fichier au format 
HDF 5 - nouvelle routine MED V2.1.5 */
ret = MEDformatConforme(inname);
if (ret == -1)                                          {
fprintf(stderr,">> ERREUR : les fichier %s n'est pas au format HDF V5 \n",inname);
exit(EXIT_FAILURE);                                     }

/* Quelle version de MED est utilise par mdump ? - nouvelle routine MED V2.1.5 */
MEDversionDonner(&majeur,&mineur,&release);
fprintf(stdout,"- Lecture du fichier a l'aide de MED V%d.%d.%d \n",
majeur,mineur,release);

fid = MEDouvrir(inname,MED_LECTURE);
exitif( fid < 0,"ouverture du du fichier ",inname);

/* oeffne ABAQUS input file */
strcpy(filename,argv[1]);
strcat(filename,".inp");
fp=fopen(filename,"w");
if(fp==NULL)                                            {
printf("error: cannot open .inp file. \n");
exit(0);                                                }

/****************************************************************************
 *    1. Mode d'affichage des coordonnees (entrelace ou non) ?               *
 *    2. Connectivite des elements (nodale ou descendante)                   *
 ****************************************************************************/
mode_coo = MED_FULL_INTERLACE;
typ_con = MED_NOD;

/****************************************************************************
*                      QUEL MAILLAGE LIRE                                   *
****************************************************************************/
nmaa = MEDnMaa(fid);
exitif(nmaa < 0,"lors de la lecture du nombre de maillages",NULL);

/* Quel maillage lire ? */
numero=1;
if (nmaa >= 2)                                    {
fprintf(stdout,"- Il y a %d maillages dans ce fichier \n",nmaa);
fprintf(stdout,"  Lequel voulez-vous lire (1|2|3|...|n) ?\n");
do                                          {
fprintf(stdout,"  Reponse : ");
scanf("%d",&numero);                        } 
while (numero > nmaa || numero <= 0);             }

/****************************************************************************
*                       INFOS GENERALES SUR LE MAILLAGE                    *
****************************************************************************/
fprintf(stdout,"\n------------------------------------------------------------\n");
fprintf(stdout,"INFORMATIONS GENERALES SUR LE MAILLAGE:\n");

/* lecture du nom et de la dimension du maillage */
ret = MEDmaaInfo(fid,numero,nommaa,&mdim,&type_maillage,maillage_description);
exitif(ret < 0,"lors de la lecture du nom du maillage",NULL);
edim = MEDdimEspaceLire(fid,nommaa);
fprintf(stdout,"- Nom du maillage : %s\n",nommaa);
fprintf(stdout,"- Dimension du maillage : %d\n",mdim);
if (edim > mdim) 
fprintf(stdout,"- La dimension de l'espace est %d \n",edim);
if (type_maillage == MED_NON_STRUCTURE)
fprintf(stdout,"- Type du maillage : MED_NON_STRUCTURE \n");
else
fprintf(stdout,"- Type du maillage : MED_STRUCTURE \n");
fprintf(stdout,"- Description associee au maillage : %s\n",maillage_description);

/* lecture du nom universel (presence optionnelle) */
ret = MEDunvLire(fid,nommaa,nom_universel);
if (ret == 0)
fprintf(stdout,"- Nom universel du maillage : %s \n",nom_universel);
else
fprintf(stdout,"- Pas de nom universel \n");

/****************************************************************************
*                      LECTURE DU MAILLAGE ET DES RESULTATS ASSOCIES        *
****************************************************************************/
/* en fonction du type du maillage */
if (type_maillage == MED_NON_STRUCTURE)
lecture_maillage_non_structure(fid,nommaa,mdim,mode_coo,typ_con,
 lecture_en_tete_seulement,fp);
else
fprintf(stdout, "sorry no conversion of structured meshes. \n");

/* write standard ABAQUS procedure calls. */
fprintf(fp,"\n*material, name=steel\n");
fprintf(fp,"*elastic\n");
fprintf(fp,"209000.0, 0.3\n");
fprintf(fp,"*density\n");
fprintf(fp,"7.85e-09\n");
fprintf(fp,"*step\n");
fprintf(fp,"*frequency\n");
fprintf(fp,"12\n");
fprintf(fp,"*nodefile\n");
fprintf(fp,"u\n");
fprintf(fp,"*elfile, output=3D\n");
fprintf(fp,"s, e\n");
fprintf(fp,"*endstep\n");
fclose(fp);

/****************************************************************************
*                      FERMETURE DU FICHIER                                 *
****************************************************************************/
fprintf(stdout, "closing medfile %s\n", inname);
ret = MEDfermer(fid);
exitif(ret < 0,"lors de la fermeture du fichier",inname);  
fprintf(stdout, "It was a pleasure serving you. Bye. \n");
fprintf(stdout, "returning to system. \n");
exit(0);                                                                       }
void exitif(int expression,char* message, char* arg)                           {
if(expression==0) return;
if(message!=NULL) fprintf(stdout, "%s", message);
if(arg!=NULL) fprintf(stdout, "%s", arg);
fprintf(stdout, "\nexiting.\n");
exit(0);                                                                       }


